if (typeof SU == 'undefined') {
	SU = {
			Globals: {}, 
			Utils: {}, 
			Renderer: {}, 
			Dialog: {}, 
			RPC: {}, 
			Admin: {},
			User: {}
	};
}

SU.Admin = {
	init: function(dlgTriggerSel, tblSel) {
		SU.Admin.initDialog(dlgTriggerSel);
		SU.Admin.initTable(tblSel);
	},

	initDialog: function(dlgTriggerSel) {
		SU.Admin.Dialog = $(dlgTriggerSel).overlay({
			closeOnClick: false						
		});
	},

	initTable: function(tblSel) {
		SU.Admin.Table = $(tblSel).tablesorter({ 
			sortList: [[0,0]],
			headers: { 
				1: { 
					sorter: false 
				}, 
			} 
		}); 
	},
	
	validate: function() {
		return true;
	},
	
	remove: function(id, name) {
		var confirmed = confirm('Are you sure you want to delete the admin \'' +
							name + '\'?');
		if (confirmed) {
			window.location.href = '/admin/remove?id=' + id;
		}
	}
};

SU.User = {
	init: function(dlgTriggerSel, tblSel) {
		SU.User.initDialog(dlgTriggerSel);
		SU.User.initTable(tblSel);
	},

	initDialog: function(dlgTriggerSel) {
		SU.User.Dialog = $(dlgTriggerSel).overlay({
			closeOnClick: false						
		});
	},

	initTable: function(tblSel) {
		SU.User.Table = $(tblSel).tablesorter({ 
			sortList: [[0,0]],
			headers: { 
				2: { 
					sorter: false 
				}, 
				3: { 
					sorter: false 
				}, 
				4: { 
					sorter: false 
				} 
			} 
		}); 
	},

	create: function() {
		$('input[name=username]').val('');
		$('input[name=fullname]').val('');
		$('input[name=address]').val('');
		$('input[name=email]').val('');
		$('input[name=phone]').val('');
		$('#create_edit_btn').val('Create');

		if (typeof SU.User.Dialog == 'undefined') {
			SU.User.initDialog();
		}
		SU.User.Dialog.overlay().load();
		$('form').get(0).setAttribute('action', '/user/create');
	},

	edit: function(id, username, fullname, address, email, phone) {
		$('input[name=userid]').val(id);
		$('input[name=username]').val(username);
		$('input[name=fullname]').val(fullname);
		$('input[name=address]').val(address);
		$('input[name=email]').val(email);
		$('input[name=phone]').val(phone);
		$('#pwd_lbl').hide();
		$('#pwd_txt').hide();
		$('#create_edit_btn').val('Save Changes');

		if (typeof SU.User.Dialog == 'undefined') {
			SU.User.initDialog();
		}
		console.log(SU.User.Dialog);
		SU.User.Dialog.overlay().load();

		// Instead of creating we want to submit this form to edit
		$('form').get(0).setAttribute('action', '/user/edit');
	},

	validate: function() {
		return true;
	},
	
	remove: function(id, name) {
		var confirmed = confirm('Are you sure you want to delete the user \'' +
							name + '\'?');
		if (confirmed) {
			window.location.href = '/user/remove?id=' + id;
		}
	}
};
