#!python2.6

import time
import sqlobject
from sqlobject.sqlite import builder

import params

class DB:

	conn = builder()(params.DBFILE)

	@classmethod
	def init_db(cls):
		try:
			ClientOrder.createTable(ifNotExists=True)
			Admin.createTable(ifNotExists=True)
			User.createTable(ifNotExists=True)
		except Exception as fault:
			print 'Unable to create tables. Error %s' % repr(fault)


class ClientOrder(sqlobject.SQLObject):

	_connection		= DB.conn	
	uid				= sqlobject.IntCol()
	papersize		= sqlobject.UnicodeCol() 
	height			= sqlobject.IntCol()
	width			= sqlobject.IntCol()
	paper			= sqlobject.UnicodeCol(default='Glossy')
	ctime			= sqlobject.IntCol()
	product			= sqlobject.UnicodeCol()
	requirements	= sqlobject.UnicodeCol()
	state			= sqlobject.IntCol()


class Admin(sqlobject.SQLObject):

	_connection		= DB.conn
	username		= sqlobject.UnicodeCol()
	passwd			= sqlobject.UnicodeCol()


class User(sqlobject.SQLObject):

	_connection		= DB.conn
	username		= sqlobject.UnicodeCol()
	passwd			= sqlobject.UnicodeCol()
	fullname		= sqlobject.UnicodeCol()
	address			= sqlobject.UnicodeCol()
	email			= sqlobject.UnicodeCol()
	phone			= sqlobject.UnicodeCol()


if __name__ == '__main__':
	print 'Creating tables if required...'
	DB.init_db()

