#!python2.6

import sys

import cherrypy

from web_utils import admin_auth
from web_utils import render

from lib import db
from lib import utils

class Admin:
	
	@cherrypy.expose
	def index(self):
		raise cherrypy.InternalRedirect('/admin/dashboard')


	@cherrypy.expose
	@admin_auth
	def dashboard(self, *args, **kwargs):
		print cherrypy.session['admin']
		#return render({
		#				'page': 'dashboard.html'
		#				})


	@cherrypy.expose
	@admin_auth
	def create(self, *args, **kwargs):
		name = kwargs['username']
		name = name.lstrip()
		name = name.rstrip()
		kwargs['username'] = name
		passwd = kwargs['passwd']
		enc_pass = utils.encrypt(passwd)
		kwargs['passwd'] = enc_pass
		print kwargs
		self._create(**kwargs)
		raise cherrypy.HTTPRedirect('/admin/list')


	def _create(self, **kwargs):
		db.DB.init_db()
		db.Admin(**kwargs)


	@cherrypy.expose
	@admin_auth
	def list(self, *args, **kwargs):
		admins = db.Admin.select()
		return render({
			'page': 'admins.html',
			'admins': list(admins)
		})

	
	@cherrypy.expose
	@admin_auth
	def remove(self, *args, **kwargs):
		admin_id = kwargs['id']
		admin = db.Admin.get(admin_id)
		admin.destroySelf()
		del admin
		raise cherrypy.HTTPRedirect('/admin/list')


if __name__ == '__main__':
	from optparse import OptionParser

	parser = OptionParser(usage=__doc__, version='SnapUp Admin setup 1.0')
	parser.add_option('-n', '--admin-name', dest='name')
	parser.add_option('-p', '--admin-pass', dest='pwd')
	opts, args = parser.parse_args()

	if not opts.name or not opts.pwd:
		parser.error('Please specify admin username and password.')
		sys.exit(-1)

	admin = Admin()
	admin._create(opts.name, opts.pwd)


