#!python2.6

import cherrypy

import web_utils

from lib import params
from admin import Admin
from user import User

class Root:

	admin = Admin()
	user = User()

	@cherrypy.expose
	def index(self):
		raise cherrypy.HTTPRedirect('/login')

	@cherrypy.expose
	def login(self, retry_msg=""):
		if 'admin' in cherrypy.session:
			raise cherrypy.HTTPRedirect('/admin/dashboard')

		elif 'user' in cherrypy.session:
			raise cherrypy.HTTPRedirect('/user')

		return login_page('', retry_msg)

	@cherrypy.expose
	def logout(self, *args, **kwargs):
		if 'admin' in cherrypy.session:
			del cherrypy.session['admin']
		
		if 'user' in cherrypy.session:
			del cherrypy.session['user']


if __name__ == '__main__':

	web_utils.init_loader()
	config = {
		'global': {
			'server.socket_host': "0.0.0.0",
            'server.socket_port': params.WEB_PORT,
            'server.thread_pool': 10,
            'engine.autoreload_on':False,
        },
        '/': {
            'tools.staticdir.root': params.WEB_DIR,
            'tools.sessions.on': True,
            'tools.sessions.timeout': 300,
            'tools.gzip.on': True,
        },
        '/images': {
            'tools.staticdir.on': True,
            'tools.staticdir.dir': "images",
        },
        '/css': {
            'tools.staticdir.on': True,
            'tools.staticdir.dir': "css",
        },
        '/js': {
            'tools.staticdir.on': True,
            'tools.staticdir.dir': "js",
        }
	}

	cherrypy.config.update(config['global'])
	cherrypy.tree.mount(Root(), config=config)

	try:
		cherrypy.engine.start()
		print 'Successfully started the SnapUp Control Panel'
		cherrypy.engine.block()
	except socket.error, fault:
		print 'Unable to start SnapUp Control Panel: ', fault
