#!python2.6

import sys

import cherrypy

from web_utils import admin_auth
from web_utils import render

from lib import db
from lib import utils

class User:

	@cherrypy.expose
	def index(self):
		raise cherrypy.InternalRedirect('/admin/dashboard')


	@cherrypy.expose
	@admin_auth
	def create(self, *args, **kwargs):
		name = kwargs['username']
		name = name.lstrip()
		name = name.rstrip()
		kwargs['username'] = name
		passwd = kwargs['passwd']
		enc_pass = utils.encrypt(passwd)
		kwargs['passwd'] = enc_pass

		# For editing, we send 'userid' as well, but don't want it during create
		if 'userid' in kwargs:
			del kwargs['userid']

		self._create(**kwargs)
		raise cherrypy.HTTPRedirect('/user/list')


	def _create(self, **kwargs):
		db.DB.init_db()
		db.User(**kwargs)


	@cherrypy.expose
	@admin_auth
	def edit(self, *args, **kwargs):
		user_id = kwargs['userid']
		del kwargs['userid']
		user = db.User.get(user_id)

		for k, v in kwargs.iteritems():
			if hasattr(user, k):
				setattr(user, k, v)
		raise cherrypy.HTTPRedirect('/user/list')

	
	@cherrypy.expose
	@admin_auth
	def list(self, *args, **kwargs):
		users = db.User.select()
		return render({
			'page': 'users.html',
			'users': list(users)
		})

	
	@cherrypy.expose
	@admin_auth
	def remove(self, *args, **kwargs):
		user_id = kwargs['id']
		user = db.User.get(user_id)
		user.destroySelf()
		del user
		raise cherrypy.HTTPRedirect('/user/list')
